diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/OS/BeOS/os_beos.h oss-v4.1test0-070624-src-gpl/kernel/OS/BeOS/os_beos.h
--- oss-v4.1test0-070624-src-gpl.org/kernel/OS/BeOS/os_beos.h	Thu Jan  1 01:00:00 1970
+++ oss-v4.1test0-070624-src-gpl/kernel/OS/BeOS/os_beos.h	Wed Jun 27 02:57:36 2007
@@ -0,0 +1,456 @@
+#ifndef _OS_H_
+#define _OS_H_
+
+/*
+ * Purpose: OS specific definitions for BeOS/Haiku
+ *
+ */
+/*
+ *
+ * This file is part of Open Sound System.
+ *
+ * Copyright (C) 4Front Technologies 1996-2007.
+ *
+ * This this source file is released under GPL v2 license (no other versions).
+ * See the COPYING file included in the main directory of this source
+ * distribution. Please contact sales@opensound.com for further info.
+ *
+ */
+#define OS_VERSION "5"
+#define __inline__ inline
+#define __inline inline
+#define EXTERN_C extern "C"
+
+/*
+ * Debugging and misc settings
+ */
+#undef DO_TIMINGS
+#undef  MUTEX_CHECKS
+#undef  MEMDEBUG
+/* very verbose */
+//#define DO_DEBUG_FUNC_CALLS
+
+/*
+ * Disable support for per-application features such as /dev/dsp device
+ * selection based on command name. Requires working GET_PROCESS_NAME
+ * macro implementation.
+ */
+//Disable??
+#define APPLIST_SUPPORT
+#define USE_DEVICE_SUBDIRS
+
+#include <OS.h>
+#include <stdarg.h>
+#include <stdint.h>
+#include <sys/types.h>
+#include <sys/param.h>
+#include <errno.h>
+#include <sys/uio.h>
+#include <sys/fcntl.h>
+#ifdef __HAIKU__
+#include <poll.h>
+#endif
+//#include <sys/malloc.h>
+#include <malloc.h>
+
+
+#include <KernelExport.h>
+#include <Drivers.h>
+#include <PCI.h>
+
+#ifndef ENOTSUP
+#define ENOTSUP ENOSYS
+#endif
+
+#define OSS_CONTIG_AREA_NAME "OSS CONTIG MEM"
+#define OSS_PCI_AREA_NAME "OSS PCI MEM"
+#define OSS_WQ_SEM_NAME "OSS WAITQ: "
+
+//#define DEVICE_PREFIX "audio/oss/"
+#define DEVICE_PREFIX ""
+#define DEVICE_NAME_LEN (32+sizeof(DEVICE_PREFIX))
+
+#ifdef _KERNEL_MODE
+
+/* references to modules */
+extern pci_module_info *gPCI;
+
+#endif /* _KERNEL_MODE */
+
+/*
+ * Some integer types
+ */
+#if defined(amd64) || defined(sparc) // 64bit ? not yet
+typedef uint64 oss_native_word;	/* Same as the address and status register size */
+#else
+typedef uint32 oss_native_word;	/* Same as the address and status register size */
+#endif
+
+typedef uint64 oss_uint64_t;	/* Unsigned 64 bit integer */
+typedef unsigned long offset_t;
+
+
+extern void oss_cmn_err (int level, char *format, ...);
+#define CE_CONT		0
+#define CE_NOTE		1
+#define CE_WARN		2
+#define CE_PANIC	3
+#define cmn_err oss_cmn_err
+
+//snooze(1000000); \
+
+#ifdef DO_DEBUG_FUNC_CALLS
+/* verbose debugging */
+#define FENTRY() \
+dprintf("oss>%s()\n", __FUNCTION__)
+#define FENTRYA(f,a...) \
+dprintf("oss>%s(" f ")\n", __FUNCTION__, a)
+#define FEXIT() \
+dprintf("oss<%s\n", __FUNCTION__)
+#define FEXITR(e) \
+dprintf("oss<%s returned 0x%08lx\n", __FUNCTION__, (uint32)e)
+#else
+#define FENTRY() {}
+#define FENTRYA(f,a...) {}
+#define FEXIT() {}
+#define FEXITR(e) {}
+#endif
+
+struct _dev_info_t
+{
+  //struct pci_dev *pcidev;
+  struct pci_info pciinfo; //XXX: ptr or not ???
+};
+typedef struct _dev_info_t dev_info_t;
+
+
+/*
+ * timeout wrappers
+ */
+#undef timeout
+#define timeout oss_timeout
+#undef untimeout
+#define untimeout oss_untimeout
+typedef int timeout_id_t;
+extern timeout_id_t oss_timeout (void (*func) (void *), void *arg,
+				 unsigned long long ticks);
+extern void oss_untimeout (timeout_id_t id);
+
+#define uiomove oss_uiomove
+typedef enum uio_rw
+{ UIO_READ, UIO_WRITE } uio_rw_t;
+struct uio
+{
+  char *ptr;
+  int resid;
+  int kernel_space;		/* Set if this uio points to a kernel space buffer */
+  uio_rw_t rw;
+};
+typedef struct uio uio_t;
+extern int oss_uiomove (void *address, size_t nbytes, enum uio_rw rwflag,
+			uio_t * uio);
+extern int oss_create_uio (uio_t * uiop, char *buf, size_t count, uio_rw_t rw,
+			   int is_kernel);
+
+
+
+/*
+ * Mutexes
+ */
+
+#ifdef MUTEX_CHECKS
+/* Debugging version */
+struct _oss_mutex_t
+{
+  spinlock lock;
+  thread_id owner;
+  char *file;
+  int line;
+  int busy_flags;
+#define CNTX_INTR		1
+#define CNTX_USER		2
+};
+
+typedef struct _oss_mutex_t oss_mutex_t;
+extern void debug_mutex_init (oss_mutex_t * mutex, char *file, int line);
+extern void debug_mutex_destroy (oss_mutex_t * mutex, char *file, int line);
+extern void debug_mutex_enter (oss_mutex_t * mutex, char *file, int line, oss_native_word *flags);
+extern void debug_mutex_exit (oss_mutex_t * mutex, char *file, int line, oss_native_word *flags);
+
+#define MUTEX_INIT(osdev, mutex, hier)			debug_mutex_init(&mutex, NULL, __FILE__, __LINE__)
+#define MUTEX_CLEANUP(mutex)			debug_mutex_destroy(&mutex, __FILE__, __LINE__)
+#define MUTEX_ENTER_IRQDISABLE(mutex, flags)	debug_mutex_enter(&mutex, __FILE__, __LINE__, &flags)
+#define MUTEX_ENTER(mutex, flags)			debug_mutex_enter(&mutex, __FILE__, __LINE__, NULL)
+#define MUTEX_EXIT_IRQRESTORE(mutex, flags)	debug_mutex_exit(&mutex, __FILE__, __LINE__, &flags)
+#define MUTEX_EXIT(mutex, flags)			debug_mutex_exit(&mutex, __FILE__, __LINE__, NULL)
+#else
+typedef spinlock oss_mutex_t;
+#define MUTEX_INIT(osdev, mutex, hier)			{ mutex = 0; }
+#define MUTEX_CLEANUP(mutex)			
+#define MUTEX_ENTER_IRQDISABLE(mutex, flags)	\
+{ \
+	flags = (oss_native_word) disable_interrupts(); \
+	acquire_spinlock(&(mutex)); \
+}
+#define MUTEX_ENTER(mutex, flags)			acquire_spinlock(&(mutex))
+#define MUTEX_EXIT_IRQRESTORE(mutex, flags)	\
+{ \
+	release_spinlock(&(mutex)); \
+	restore_interrupts((cpu_status)(flags)); \
+}
+#define MUTEX_EXIT(mutex, flags)			release_spinlock(&(mutex))
+#endif
+
+/* The soundcard.h could be in a nonstandard place so include it here. */
+#include "soundcard.h"
+
+typedef struct udi_usb_devc udi_usb_devc;
+struct _oss_device_t
+{
+#ifdef NEEDED_FOR_DRIVERS
+  int instance;
+  void *devc;
+  char *name;
+#endif
+
+  int cardnum;
+  int dev_type;
+  int instance;
+  dev_info_t *dip;
+  int unloaded;
+  void *osid;
+  void *devc;
+  char *name;
+  char nick[16];
+  char modname[32];
+  char handle[32];
+  int num_audio_engines;
+  int num_audioplay, num_audiorec, num_audioduplex;
+  int num_mididevs;
+  int num_mixerdevs;
+  
+  volatile int refcount;	/* Nonzero means that the device is needed by some other (virtual) driver. */
+
+/* Interrupts */
+
+  long irq; //XXX:init =-1
+  oss_tophalf_handler_t tophalf_handler;
+  oss_bottomhalf_handler_t bottomhalf_handler;
+  oss_mutex_t mutex;
+
+};
+
+/* XXX we'll deal with select() later */
+#undef ALLOW_SELECT
+/* BeOS doesn't support mmap. Haiku does, so FIXME someday */
+#undef ALLOW_BUFFER_MAPPING
+
+/*
+ * Sleep/wakeup
+ */
+
+#ifdef _KERNEL
+struct oss_wait_queue
+{
+//XXX:
+//  oss_mutex_t mutex;
+  char name[32];
+  sem_id sem;
+  unsigned long flags;
+//  struct selinfo poll_info;
+};
+#endif
+
+/* Busy wait routine */
+#define oss_udelay(d) spin((bigtime_t)d)
+
+
+/* usec time base */
+#undef HZ
+/* XXX: might need to be lower to handle casts to long */
+#define OSS_HZ 1000000
+
+/* System wall timer access */
+extern unsigned long oss_get_time (void);
+#define GET_JIFFIES()	oss_get_time()
+
+
+/*
+ * INB() and OUTB() should be obvious. NOTE! The order of
+ * paratemeters of OUTB() is different than on some other
+ * operating systems.
+ */
+
+/* I/O Mapped devices */
+#define INB(o, p)	gPCI->read_io_8(p)
+#define INW(o, p)	gPCI->read_io_16(p)
+#define INL(o, p)	gPCI->read_io_32(p)
+
+#define OUTB(o, v, p)	gPCI->write_io_8(p,v)
+#define OUTW(o, v, p)	gPCI->write_io_16(p,v)
+#define OUTL(o, v, p)	gPCI->write_io_32(p,v)
+
+/* Memory Mapped devices */
+#define PCI_READB(osdev, addr)		*(volatile unsigned char *)(addr)
+#define PCI_READW(osdev, addr)		*(volatile unsigned short *)(addr)
+#define PCI_READL(osdev, addr)		*(volatile unsigned int *)(addr)
+
+#define PCI_WRITEB(osdev, addr, data)	*(volatile unsigned char *)(addr)=data
+#define PCI_WRITEW(osdev, addr, data)	*(volatile unsigned short *)(addr)=data
+#define PCI_WRITEL(osdev, addr, data)	*(volatile unsigned int *)(addr)=data
+
+/*
+ * When a error (such as EINVAL) is returned by a function,
+ * the following macro is used. The driver assumes that a
+ * error is signalled by returning a negative value.
+ */
+
+/* 
+   KERNEL_MALLOC() allocates requested number of memory  and 
+   KERNEL_FREE is used to free it. 
+   These macros are never called from interrupt, in addition the
+   nbytes will never be more than 4096 bytes. Generally the driver
+   will allocate memory in blocks of 4k. If the kernel has just a
+   page level memory allocation, 4K can be safely used as the size
+   (the nbytes parameter can be ignored).
+*/
+#define	KERNEL_MALLOC(nbytes)	malloc(nbytes)
+#define	KERNEL_FREE(addr)	{if (addr)free(addr);addr=NULL;}
+
+extern void *oss_contig_malloc (oss_device_t * osdev, int sz,
+				oss_uint64_t memlimit,
+				oss_native_word * phaddr);
+extern void oss_contig_free (oss_device_t * osdev, void *p, int sz);
+extern oss_native_word oss_virt_to_bus (void *addr);
+#define CONTIG_MALLOC(osdev, sz, memlimit, phaddr)	oss_contig_malloc(osdev, sz, memlimit, phaddr)
+#define CONTIG_FREE(osdev, p, sz)	oss_contig_free(osdev, p, sz)
+
+/*
+ * PMALLOC is used to allocate memory that will get automatically freed when
+ * OSS unloads. Usable for per-instance structures allocated when OSS modules
+ * are being loaded.
+ */
+extern void *oss_pmalloc (size_t sz);
+
+#define PMALLOC(osdev, sz) oss_pmalloc(sz)
+
+/*
+ * Timer macros
+ *
+ * These macros are obsolete and should not be used in any new code.
+ * Use the timeout mechanism (see the timeout(9F) Solaris man page).
+ */
+#define DEFINE_TIMER(name, proc)	static timeout_id_t name = 0
+#define REMOVE_TIMER(name, proc)	{if (name != 0) untimeout(name);}
+#define INIT_TIMER(name,proc)
+typedef void (*timeout_func_t) (void *);
+#define ACTIVATE_TIMER(name, proc, time) \
+	name=timeout((timeout_func_t)proc, (void*)&name, time)
+#endif
+
+struct fileinfo
+{
+  int mode;			/* Open mode */
+  int flags;
+  int acc_flags;
+};
+#define ISSET_FILE_FLAG(fileinfo, flag)  (fileinfo->acc_flags & (flag) ? 1:0)
+
+#define OSS_OS "BeOS"
+#define OSS_OS_LONGNAME "BeOS R" OS_VERSION
+
+typedef void (*softintr_func_t) (int);
+
+struct oss_softintr
+{
+  int id;
+  softintr_func_t func;
+  volatile int armed, running;
+};
+
+struct _oss_poll_event_t
+{
+  short events, revents;
+  struct thread *p;
+  struct cdev *bsd_dev;
+};
+typedef struct _oss_poll_event_t oss_poll_event_t;
+#ifndef POLLIN
+/* events & revents - compatible with the B_SELECT_xxx definitions in Drivers.h */
+#define POLLIN          0x0001          /* any readable data available */
+#define POLLOUT         0x0002          /* file descriptor is writeable */
+#define POLLRDNORM      POLLIN
+#define POLLWRNORM      POLLOUT
+#define POLLRDBAND      0x0008          /* priority readable data */
+#define POLLWRBAND      0x0010          /* priority data can be written */
+#define POLLPRI         0x0020          /* high priority readable data */
+#endif
+
+extern int detect_trace;
+#define DDB(x) if (detect_trace) x
+
+extern caddr_t oss_map_pci_mem (oss_device_t * osdev, int nr, int phaddr,
+				int size);
+extern void oss_unmap_pci_mem (void *addr);
+#define MAP_PCI_IOADDR(osdev, nr, io) (oss_native_word)io
+#define MAP_PCI_MEM(osdev, ix, phaddr, size) 	oss_map_pci_mem(osdev, ix, phaddr, size)
+#define UNMAP_PCI_MEM(osdev, ph, virt, size)	oss_unmap_pci_mem(virt)
+
+#define GET_PROCESS_PID(f)  find_thread(NULL)
+#define GET_PROCESS_NAME(f) NULL
+
+#define abs(x)                  ((x) >= 0 ? (x) : -(x))
+
+/*
+ * PCI config space access (in os.c)
+ */
+extern char *oss_pci_read_devpath (dev_info_t * dip);
+
+
+/*
+ * Interface with the front-end driver
+ */
+extern status_t init_osscore (void);
+extern status_t uninit_osscore (void);
+extern status_t oss_probe_pci (void);
+extern status_t oss_load_drivers (void);
+extern status_t oss_unload_all_drivers (void);
+
+/*
+ * osscore module for use by low-level driver
+ */
+#define OSS_CORE_MODULE_NAME "media/oss/osscore/v1"
+#define OSS_MODULES_PREFIX "media/oss/drivers/"
+#define OSS_MODULES_SUFFIX "/v1"
+#define OSS_MAKE_DRV_MOD_NAME(nick) OSS_MODULES_PREFIX nick OSS_MODULES_SUFFIX
+typedef struct oss_drv_module_info {
+  module_info minfo;
+  int (*driver_probe)(void);
+  int (*driver_attach)(oss_device_t *osdev);
+  int (*driver_detach)(oss_device_t *osdev);
+} oss_drv_module_info;
+
+typedef struct oss_core_module_info {
+  module_info minfo;
+  status_t (*init_osscore) (void);
+  status_t (*uninit_osscore) (void);
+  const char **(*oss_publish_devices) (void);
+  device_hooks *(*oss_get_driver_hooks) (void);
+  status_t (*oss_probe_pci) (void);
+  status_t (*oss_load_drivers) (void);
+  status_t (*oss_unload_all_drivers) (void);
+} oss_core_module_info;
+extern oss_core_module_info *gOSSCore;
+
+//XXX: not yet
+#ifdef ASMODULES
+
+struct oss_core_module {
+  module_info minfo;
+  void (*oss_foo)(void);
+};
+extern struct oss_core_info *gOSSCore;
+#ifdef BUILDING_DRIVER
+  #define oss_foo gOSSCore->oss_foo
+#endif
+#endif /* ASMODULES */
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/OS/FreeBSD/os_freebsd.c oss-v4.1test0-070624-src-gpl/kernel/OS/FreeBSD/os_freebsd.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/OS/FreeBSD/os_freebsd.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/OS/FreeBSD/os_freebsd.c	Tue Jun 26 22:19:34 2007
@@ -89,7 +89,7 @@
 
   tmpbuf = CONTIG_MALLOC (dmap->osdev, size, maxaddr, &phaddr);
   if (tmpbuf == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   dmap->dmabuf = tmpbuf;
   dmap->buffsize = size;
   dmap->dmabuf_phys = phaddr;
@@ -213,7 +213,7 @@
   strcpy (osdev->name, name);
   if (osdev->dip != NULL)
     device_set_desc (osdev->dip, name);
-  return -ENXIO;
+  return RETERR(ENXIO);
 }
 
 void
@@ -256,10 +256,10 @@
   int i;
 
   if (osdev->refcount > 0)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   if (open_devices > 0)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   for (i = 0; i < num_mixers; i++)
     if (mixer_devs[i]->osdev == osdev)
@@ -293,7 +293,7 @@
  */
 
   if (cardnum < 0 || cardnum >= oss_num_cards)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cards[cardnum]->name != NULL)
     strncpy (ci->longname, cards[cardnum]->name, 128);
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/OS/Linux/os_linux.c oss-v4.1test0-070624-src-gpl/kernel/OS/Linux/os_linux.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/OS/Linux/os_linux.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/OS/Linux/os_linux.c	Tue Jun 26 22:19:34 2007
@@ -298,7 +298,7 @@
  */
   if (osdev->refcount > 0)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   for (i = 0; i < num_mixers; i++)
@@ -374,7 +374,7 @@
  */
 
   if (cardnum < 0 || cardnum >= oss_num_cards)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cards[cardnum]->name != NULL)
     strncpy (ci->longname, cards[cardnum]->name, 128);
@@ -406,7 +406,7 @@
   if (dmap == NULL)
     {
       cmn_err (CE_WARN, "oss_alloc_dmabuf: dmap==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
 /*
@@ -436,7 +436,7 @@
 			      &phaddr)) == NULL)
 	{
 	  if ((dmap->buffsize = (dmap->buffsize / 2)) < 8 * 1024)
-	    return -ENOMEM;
+	    return RETERR(ENOMEM);
 	  cmn_err (CE_CONT, "Dropping DMA buffer size to %d bytes.\n",
 		   dmap->buffsize);
 	  continue;
@@ -448,7 +448,7 @@
       return 0;
     }
 
-  return -ENOMEM;
+  return RETERR(ENOMEM);
 }
 
 void
@@ -493,9 +493,9 @@
   oss_cdev_t *cdev;
 
   if (dev > oss_num_cdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if ((cdev = oss_cdevs[dev]) == NULL || cdev->d == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   DDB (cmn_err
        (CE_CONT, "oss_cdev_open(%d): %s, class=%d, instance=%d\n", dev,
@@ -503,7 +503,7 @@
 
   if (cdev->d->open == NULL)
     {
-      return -ENODEV;
+      return RETERR(ENODEV);
     }
 
   dev_class = cdev->dev_class;
@@ -566,10 +566,10 @@
   cpy_file (file, &fi);
 
   if (dev > oss_num_cdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if ((cdev = oss_cdevs[dev]) == NULL || cdev->d->read == NULL)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   if ((err = oss_create_uio (&uio, buf, count, UIO_READ, 0)) < 0)
@@ -596,10 +596,10 @@
   cpy_file (file, &fi);
 
   if (dev > oss_num_cdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if ((cdev = oss_cdevs[dev]) == NULL || cdev->d->write == NULL)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   if ((err = oss_create_uio (&uio, buf, count, UIO_WRITE, 0)) < 0)
@@ -630,10 +630,10 @@
   cpy_file (file, &fi);
 
   if (dev > oss_num_cdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if ((cdev = oss_cdevs[dev]) == NULL || cdev->d->ioctl == NULL)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   if (__SIOC_DIR (cmd) != __SIOC_NONE && __SIOC_DIR (cmd) != 0)
@@ -642,7 +642,7 @@
       if (len < 1 || len > 65536 || arg == 0)
 	{
 	  cmn_err (CE_WARN, "Bad ioctl command %x, %d, %x\n", cmd, len, arg);
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 	}
 
       /* Use statically allocated buffer for short arguments */
@@ -656,7 +656,7 @@
 
       if (ptr == NULL || arg == 0)
 	{
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 	}
 
       if (__SIOC_DIR (cmd) & __SIOC_WRITE)
@@ -665,7 +665,7 @@
 	    {
 	      if (alloced)
 		KERNEL_FREE (ptr);
-	      return -EFAULT;
+	      return RETERR(EFAULT);
 	    }
 	}
     }
@@ -683,7 +683,7 @@
 	{
 	  if (alloced)
 	    KERNEL_FREE (ptr);
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 	}
     }
 
@@ -709,10 +709,10 @@
   cpy_file (file, &fi);
 
   if (dev > oss_num_cdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if ((cdev = oss_cdevs[dev]) == NULL || cdev->d->chpoll == NULL)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   ev.wait = wait;
@@ -738,21 +738,21 @@
   int err;
 
   if (dev > oss_num_cdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if ((cdev = oss_cdevs[dev]) == NULL)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   if (cdev->dev_class != OSS_DEV_DSP && cdev->dev_class != OSS_DEV_DSP_ENGINE)	/* Only mmap audio devices */
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   dev = cdev->instance;
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (oss_vma_get_flags (vma) & VM_WRITE)	/* Map write and read/write to the output buf */
     {
@@ -765,38 +765,38 @@
   else
     {
       cmn_err (CE_WARN, "Undefined mmap() access\n");
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (dmap == NULL)
     {
       cmn_err (CE_WARN, "mmap() error. dmap == NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap->dmabuf == NULL)
     {
       cmn_err (CE_WARN, "mmap() called when raw_buf == NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap->dmabuf_phys == 0)
     {
       cmn_err (CE_WARN, "mmap() not supported by device /dev/dsp%d.\n", dev);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap->mapping_flags)
     {
       cmn_err (CE_WARN, "mmap() called twice for the same DMA buffer\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap->flags & DMAP_COOKED)
     {
       cmn_err (CE_WARN,
 	       "mmap() not possible with currently selected sample format.\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if ((err = oss_do_mmap (vma, dmap->dmabuf_phys, dmap->bytes_in_use)) < 0)
@@ -930,7 +930,7 @@
     {
       cmn_err (CE_WARN, "Failed to allocate character major number %d\n",
 	       osscore_major);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   osdev->major = osscore_major;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/OS/SCO_SV/os_sco.c oss-v4.1test0-070624-src-gpl/kernel/OS/SCO_SV/os_sco.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/OS/SCO_SV/os_sco.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/OS/SCO_SV/os_sco.c	Tue Jun 26 22:19:34 2007
@@ -236,7 +236,7 @@
   if ((p =
        oss_contig_malloc (audio_engines[dev]->osdev, size, maxaddr,
 			  &phaddr)) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   dmap->dmabuf = p;
   dmap->dmabuf_phys = phaddr;
@@ -493,7 +493,7 @@
  */
 
   if (cardnum < 0 || cardnum >= oss_num_cards)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cards[cardnum]->name != NULL)
     strncpy (ci->longname, cards[cardnum]->name, 128);
@@ -722,7 +722,7 @@
   int i;
 /*
  * This routine should check if the device is ready to be unloaded (no devices are in use).
- * If the device cannot be unloaded this routine must return -EBUSY.
+ * If the device cannot be unloaded this routine must return RETERR(EBUSY).
  *
  * If the device can be unloaded then disable any timers or other features that may cause the
  * device to be called. Also mark the audio/midi/mixer/etc devices of this device to be disabled.
@@ -731,7 +731,7 @@
  */
   if (osdev->refcount > 0)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
 /*
@@ -818,26 +818,26 @@
     {
       cmn_err (CE_WARN, "Bad interrupt index (%d) for %s\n", intrnum,
 	       osdev->name);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (osdev == NULL)
     {
       cmn_err (CE_WARN, "oss_register_interrupts: Bad osdev\n");
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (osdev->tophalf_handler != NULL || osdev->bottomhalf_handler != NULL)
     {
       cmn_err (CE_WARN, "Interrupts already registered for %s\n",
 	       osdev->name);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (top == NULL)
     {
       cmn_err (CE_WARN, "Bad interrupt handler for %s\n", osdev->name);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   osdev->tophalf_handler = top;
@@ -1013,13 +1013,13 @@
   int i;
 
   if (drvinfo_busy)
-    return -EBUSY;
+    return RETERR(EBUSY);
   drvinfo_busy = 1;
 
   if ((drvinfo_buf = KERNEL_MALLOC (DRVINFO_SIZE)) == NULL)
     {
       cmn_err (CE_WARN, "Cannot allocate drvinfo buffer\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   drvinfo_len = 0;
@@ -1067,7 +1067,7 @@
     return 0;
 
   if (uiomove (&drvinfo_buf[drvinfo_ptr], l, UIO_READ, buf) != 0)
-    return -EFAULT;
+    return RETERR(EFAULT);
   drvinfo_ptr += l;
 
   return l;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/OS/SunOS/os_solaris.c oss-v4.1test0-070624-src-gpl/kernel/OS/SunOS/os_solaris.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/OS/SunOS/os_solaris.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/OS/SunOS/os_solaris.c	Tue Jun 26 22:19:34 2007
@@ -1499,7 +1499,7 @@
  */
 
   if (cardnum < 0 || cardnum >= oss_num_cards)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cards[cardnum]->name != NULL)
     strncpy (ci->longname, cards[cardnum]->name, 128);
@@ -1668,19 +1668,19 @@
   if (osdev == NULL)
     {
       cmn_err (CE_WARN, "oss_alloc_dmabuf: osdev==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (osdev->dip == NULL)
     {
       cmn_err (CE_WARN, "oss_alloc_dmabuf: osdev->dip==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap == NULL)
     {
       cmn_err (CE_WARN, "oss_alloc_dmabuf: dmap==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if ((err = ddi_dma_alloc_handle (osdev->dip,
@@ -1690,7 +1690,7 @@
 				   &dmap->dma_parms.dhandle)) != DDI_SUCCESS)
     {
       cmn_err (CE_WARN, "Failed to allocate DMA handle (error %d)\n", err);
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   dmap->dmabuf = NULL;
@@ -1722,7 +1722,7 @@
       if (!(alloc_flags & DMABUF_QUIET))
 	cmn_err (CE_WARN, "Can't allocate a DMA buffer for device %d\n", dev);
       ddi_dma_free_handle (&dmap->dma_parms.dhandle);
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   dmap->buffsize = len;
@@ -1743,7 +1743,7 @@
     {
       cmn_err (CE_WARN, "DMA address setup failed (%d)\n", err);
 
-      return -EIO;
+      return RETERR(EIO);
     }
 
   dmap->dmabuf =
@@ -1752,7 +1752,7 @@
 
   desc = PMALLOC (osdev, sizeof (contig_desc));
   if (desc == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   desc->osdev = osdev;
   desc->next = NULL;
@@ -1843,26 +1843,26 @@
     {
       cmn_err (CE_WARN, "Bad interrupt index (%d) for %s\n", intrnum,
 	       osdev->name);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (osdev == NULL)
     {
       cmn_err (CE_WARN, "oss_register_interrupts: Bad osdev\n");
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (osdev->tophalf_handler != NULL || osdev->bottomhalf_handler != NULL)
     {
       cmn_err (CE_WARN, "Interrupts already registered for %s\n",
 	       osdev->name);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (top == NULL)
     {
       cmn_err (CE_WARN, "Bad interrupt handler for %s\n", osdev->name);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   osdev->tophalf_handler = top;
@@ -1875,14 +1875,14 @@
 	  cmn_err (CE_WARN,
 		   "The driver for %s doesn't support hilevel interrupts\n",
 		   osdev->name);
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       DDB (cmn_err (CE_NOTE, "Using hilevel intr for %s\n", osdev->name));
 
       /* TODO: Fix hilevel intr handling */
       cmn_err (CE_WARN, "Hilevel interrupts are not supported yet.\n");
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
   else
     {
@@ -1894,7 +1894,7 @@
 			   oss_intr, (caddr_t) osdev)) != DDI_SUCCESS)
     {
       cmn_err (CE_WARN, "ddi_add_intr() failed, error=%d\n", err);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return 0;
@@ -1930,7 +1930,7 @@
   int i;
 /*
  * This routine should check if the device is ready to be unloaded (no devices are in use).
- * If the device cannot be unloaded this routine must return -EBUSY.
+ * If the device cannot be unloaded this routine must return RETERR(EBUSY).
  *
  * If the device can be unloaded then disable any timers or other features that may cause the
  * device to be called. Also mark the audio/midi/mixer/etc devices of this device to be disabled.
@@ -1941,7 +1941,7 @@
     {
       cmn_err (CE_CONT, "Refcount %d, open_devices %d\n", osdev->refcount,
 	       open_devices);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
 /*
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/OS/SunOS/udi.c oss-v4.1test0-070624-src-gpl/kernel/OS/SunOS/udi.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/OS/SunOS/udi.c	Tue Jun 12 14:22:35 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/OS/SunOS/udi.c	Tue Jun 26 22:19:34 2007
@@ -391,7 +391,7 @@
        usb_set_alt_if (usbdev->osdev->dip, inum, altset, USB_FLAGS_SLEEP,
 		       NULL, 0)) != USB_SUCCESS)
     {
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return 0;
@@ -532,7 +532,7 @@
   if (usbdev == NULL)
     {
       cmn_err (CE_CONT, "udi_usb_snd_control_msg: usbdev==NULL\n");
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   data = allocb_wait (len + 1, BPRI_HI, STR_NOSIG, NULL);
@@ -558,7 +558,7 @@
       cmn_err (CE_CONT, "bRq %x, wIx %x, wVal %x, wLen %d\n", rq, index,
 	       value, len);
       freemsg (data);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   freemsg (data);
@@ -583,7 +583,7 @@
   if (usbdev == NULL)
     {
       cmn_err (CE_CONT, "udi_usb_rcv_control_msg: usbdev==NULL\n");
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   setup.bmRequestType = rqtype | USB_DEV_REQ_DEV_TO_HOST;
@@ -602,7 +602,7 @@
       cmn_err (CE_NOTE, "usb_pipe_ctrl_xfer_wait read failed: %s (%s)\n",
 	       usb_errstr (err), usb_cb_err (completion_reason));
       freemsg (data);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   l = data->b_wptr - data->b_rptr;
@@ -944,7 +944,7 @@
 	      {
 		cmn_err (CE_WARN, "allocb_wait (isoc) failed\n");
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 
 	    if ((isoc_req = usb_alloc_isoc_req (req->dip, 1, 0, 0)) == NULL)
@@ -952,7 +952,7 @@
 		cmn_err (CE_WARN, "usb_alloc_isoc_req failed\n");
 		freemsg (req->data);
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 	    req->isoc_req = isoc_req;
 	  }
@@ -960,7 +960,7 @@
 	if (isoc_req == NULL)
 	  {
 	    cmn_err (CE_WARN, "req->isoc==NULL\n");
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 
 	memcpy (req->data->b_wptr, data, len);
@@ -982,7 +982,7 @@
 	  {
 	    cmn_err (CE_WARN, "usb_pipe_isoc_xfer failed (%s)\n",
 		     usb_errstr (err));
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 	req->active = 1;
       }
@@ -1002,7 +1002,7 @@
 	      {
 		cmn_err (CE_WARN, "usb_alloc_isoc_req failed\n");
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 	    req->isoc_req = isoc_req;
 	  }
@@ -1010,7 +1010,7 @@
 	if (isoc_req == NULL)
 	  {
 	    cmn_err (CE_WARN, "req->isoc==NULL\n");
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 
 	isoc_req->isoc_attributes = USB_ATTRS_ISOC_XFER_ASAP;
@@ -1028,7 +1028,7 @@
 	  {
 	    cmn_err (CE_WARN, "usb_pipe_isoc_xfer failed (%s)\n",
 		     usb_errstr (err));
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
       }
       break;
@@ -1046,7 +1046,7 @@
 	      {
 		cmn_err (CE_WARN, "allocb_wait (bulk) failed\n");
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 
 	    if ((bulk_req = usb_alloc_bulk_req (req->dip, len, 0)) == NULL)
@@ -1054,7 +1054,7 @@
 		cmn_err (CE_WARN, "usb_alloc_bulk_req failed\n");
 		freemsg (req->data);
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 	    req->bulk_req = bulk_req;
 	  }
@@ -1062,7 +1062,7 @@
 	if (bulk_req == NULL)
 	  {
 	    cmn_err (CE_WARN, "req->bulk==NULL\n");
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 
 	memcpy (req->data->b_wptr, data, len);
@@ -1082,7 +1082,7 @@
 	  {
 	    cmn_err (CE_WARN, "usb_pipe_bulk_xfer failed (%s)\n",
 		     usb_errstr (err));
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 	req->active = 1;
       }
@@ -1102,7 +1102,7 @@
 	      {
 		cmn_err (CE_WARN, "allocb_wait (bulk) failed\n");
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 #endif
 
@@ -1112,7 +1112,7 @@
 		cmn_err (CE_WARN, "usb_alloc_bulk_req failed\n");
 		freemsg (req->data);
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 	    req->bulk_req = bulk_req;
 	  }
@@ -1120,7 +1120,7 @@
 	if (bulk_req == NULL)
 	  {
 	    cmn_err (CE_WARN, "req->bulk==NULL\n");
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 
 	bulk_req->bulk_attributes = USB_ATTRS_SHORT_XFER_OK;
@@ -1138,7 +1138,7 @@
 	  {
 	    cmn_err (CE_WARN, "usb_pipe_bulk_xfer failed (%s)\n",
 		     usb_errstr (err));
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
       }
       break;
@@ -1157,7 +1157,7 @@
 	      {
 		cmn_err (CE_WARN, "allocb_wait (intr) failed\n");
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 #endif
 
@@ -1167,7 +1167,7 @@
 		cmn_err (CE_WARN, "usb_alloc_intr_req failed\n");
 		freemsg (req->data);
 		KERNEL_FREE (req);
-		return -ENOMEM;
+		return RETERR(ENOMEM);
 	      }
 	    req->intr_req = intr_req;
 	  }
@@ -1175,7 +1175,7 @@
 	if (intr_req == NULL)
 	  {
 	    cmn_err (CE_WARN, "req->intr==NULL\n");
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 
 	intr_req->intr_attributes =
@@ -1194,14 +1194,14 @@
 	  {
 	    cmn_err (CE_WARN, "usb_pipe_intr_xfer failed (%s)\n",
 		     usb_errstr (err));
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
       }
       break;
 
     default:
       cmn_err (CE_WARN, "Unimplemented transfer type %d\n", xfer_type);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return 0;
